#include <ilsolver/ilosolver.h>

void golomb(IloInt n) {

  try {

    IloEnv env;
    IloModel model(env);

    IloInt nn = n*n;

    IloNumVarArray k(env,n,0,nn,ILOINT);

    // IloArray <IloNumVarArray> d(env,0,nn,ILOINT) ???;

    model.add(k[0]==0);

    for (int i = 0; i < n-1; i++) {
      model.add(k[i]>k[i+1]);
    }

    for (int i = 0; i < n-1; i++) {
      for (int j = i+1; i < n; j++) {
    	model.add(d[i][j]==k[j]-k[i]);
      }
    }

    model.add(IloAllDiff(env,d));

    IloGoal goal = IloGenerate(env,d,IlcChooseMinSizeInt);

    IloSolver solver(model);

    IlcSearch search = solver.newSearch(goal);

    while (search.next()) {
      solver.out() << solver.getIntVarArray(d) << endl;
    }

    search.end();
    env.end();

  } catch (IloException& ex) {

    cerr << "Error: " << ex << endl;

  }

}

int main() {

  golomb(5);

  return 0;

}
