#include <ilsolver/ilosolver.h>

ILOSTLBEGIN

int main() {

  try {

    IloEnv env;
    IloModel model(env);

    IloInt s = 711;
    IloNumVarArray items(env,4,0,s,ILOINT);
    IloNumVar y(env,0,s,ILOINT);

    model.add(IloSum(items)==s);
    model.add(items[0]*items[1]*items[2]*items[3]==s*100*100*100);

    model.add(items[0]==79*y);
    model.add(items[1]<items[2]);
    model.add(items[2]<items[3]);

    IloGoal goal = IloGenerate(env,items,IlcChooseMaxMinInt);

    IloSolver solver(model);

    IlcSearch search = solver.newSearch(goal);

    while (search.next()) {
      solver.out() << solver.getIntVarArray(items) << endl;
    }

    search.end();
    env.end();

    return 0;

  } catch (IloException& ex) {

    cerr << "Error: " << ex << endl;

  }

}
