#include <ilsolver/ilosolver.h>

ILOSTLBEGIN

int main() {

  try {

    IloEnv env;
    IloModel model(env);

    IloNumVarArray code(env,9,1,9,ILOINT);

    model.add(IloAllDiff(env,code));

    model.add(code[3]-code[5]==code[6]);
    model.add(code[0]*code[1]*code[2]==code[7]+code[8]);
    model.add(code[1]+code[2]+code[5]<code[7]);
    model.add(code[8]<code[7]);

    for (int i = 0; i < code.getSize(); i++) {
      model.add(code[i]!=i+1);
    }

    IloGoal goal = IloGenerate(env,code,IlcChooseMinSizeInt);

    IloSolver solver(model);

    IlcSearch search = solver.newSearch(goal);

    while (search.next()) {
      solver.out() << solver.getIntVarArray(code) << endl;
    }

    search.end();
    env.end();

    return 0;

  } catch (IloException& ex) {

    cerr << "Error: " << ex << endl;

  }

}
